# Generated by Django 2.2.12 on 2021-07-20 18:41

from django.db import migrations
from django.db.models import Q


def set_node_dynamic(apps, schema_editor):
    Node = apps.get_model("maasserver", "Node")
    nodes = Node.objects.filter(
        (
            # either a MAAS controllers or linked to a VM host
            Q(node_type__in=(2, 3, 4))
            | Q(podhints__pod__power_type__in=("virsh", "lxd"))
        ),
        bmc__isnull=True,
        dynamic=False,
    )
    nodes.update(dynamic=True)


class Migration(migrations.Migration):

    dependencies = [
        ("maasserver", "0242_forwarddnsserver"),
    ]

    operations = [
        migrations.RunPython(set_node_dynamic),
    ]
