# Generated by Django 2.2.12 on 2021-07-20 18:41

from django.db import migrations

DEPLOYED = 6
RACK_CONTROLLER = 2
REGION_CONTROLLER = 3
REGION_AND_RACK_CONTROLLER = 4


def set_node_deployed(apps, schema_editor):
    Node = apps.get_model("maasserver", "Node")
    controller_nodes = Node.objects.filter(
        node_type__in=(
            RACK_CONTROLLER,
            REGION_CONTROLLER,
            REGION_AND_RACK_CONTROLLER,
        ),
        bmc__isnull=True,
        dynamic=True,
    )
    controller_nodes.update(status=DEPLOYED)


class Migration(migrations.Migration):

    dependencies = [
        ("maasserver", "0243_node_dynamic_for_controller_and_vmhost"),
    ]

    operations = [
        migrations.RunPython(set_node_deployed),
    ]
