# Generated by Django 2.2.12 on 2022-01-13 09:53

from django.db import migrations, models
import django.db.models.deletion


def link_current_node_configs(apps, schema_editor):
    Node = apps.get_model("maasserver", "Node")
    NodeConfig = apps.get_model("maasserver", "NodeConfig")

    # currently there's only one
    node_config_entries = NodeConfig.objects.filter(
        name="discovered"
    ).values_list("id", "node_id")
    for config_id, node_id in node_config_entries:
        Node.objects.filter(id=node_id).update(current_config_id=config_id)


class Migration(migrations.Migration):

    dependencies = [
        ("maasserver", "0254_default_nodeconfig_devices"),
    ]

    operations = [
        migrations.AddField(
            model_name="node",
            name="current_config",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="maasserver.NodeConfig",
            ),
        ),
        migrations.RunPython(link_current_node_configs),
    ]
