# Generated by Django 2.2.12 on 2022-03-30 11:57

from django.db import migrations, models

OLD_INDEXES = (
    "maasserver_notification_ident",
    "maasserver_staticipaddress__discovered_unique",
    "maasserver_interface_node_config_mac_address_idx",
)


class Migration(migrations.Migration):

    dependencies = [
        ("maasserver", "0270_storage_uuid_drop_unique"),
    ]

    operations = [
        migrations.RunSQL(f"DROP INDEX {name}") for name in OLD_INDEXES
    ] + [
        migrations.AlterField(
            model_name="notification",
            name="ident",
            field=models.CharField(
                blank=True, default=None, max_length=40, null=True, unique=True
            ),
        ),
        migrations.AddConstraint(
            model_name="staticipaddress",
            constraint=models.UniqueConstraint(
                condition=models.Q(_negated=True, alloc_type=6),
                fields=("ip",),
                name="maasserver_staticipaddress_discovered_uniq",
            ),
        ),
        migrations.AddConstraint(
            model_name="interface",
            constraint=models.UniqueConstraint(
                condition=models.Q(type="physical"),
                fields=("node_config", "mac_address"),
                name="maasserver_interface_node_config_mac_address_uniq",
            ),
        ),
    ]
