# Generated by Django 2.2.12 on 2022-03-30 11:39

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ("maasserver", "0271_interface_unique"),
    ]

    operations = [
        migrations.AlterField(
            model_name="virtualmachine",
            name="bmc",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                to="maasserver.BMC",
            ),
        ),
        migrations.AlterField(
            model_name="virtualmachine",
            name="machine",
            field=models.OneToOneField(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name="virtualmachine",
                to="maasserver.Machine",
            ),
        ),
        migrations.AlterField(
            model_name="virtualmachinedisk",
            name="backing_pool",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="maasserver.PodStoragePool",
            ),
        ),
        migrations.AlterField(
            model_name="virtualmachinedisk",
            name="block_device",
            field=models.OneToOneField(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name="vmdisk",
                to="maasserver.BlockDevice",
            ),
        ),
        migrations.AlterField(
            model_name="virtualmachinedisk",
            name="vm",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="maasserver.VirtualMachine",
            ),
        ),
        migrations.AlterField(
            model_name="virtualmachineinterface",
            name="vm",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="maasserver.VirtualMachine",
            ),
        ),
        migrations.AlterUniqueTogether(
            name="virtualmachinedisk",
            unique_together=set(),
        ),
        migrations.AlterUniqueTogether(
            name="virtualmachineinterface",
            unique_together=set(),
        ),
        migrations.AddConstraint(
            model_name="virtualmachinedisk",
            constraint=models.UniqueConstraint(
                condition=models.Q(block_device__isnull=True),
                fields=("vm", "name"),
                name="maasserver_virtualmachinedisk_no_bdev_uniq",
            ),
        ),
        migrations.AddConstraint(
            model_name="virtualmachinedisk",
            constraint=models.UniqueConstraint(
                condition=models.Q(block_device__isnull=False),
                fields=("vm", "name", "block_device"),
                name="maasserver_virtualmachinedisk_bdev_uniq",
            ),
        ),
        migrations.AddConstraint(
            model_name="virtualmachineinterface",
            constraint=models.UniqueConstraint(
                condition=models.Q(host_interface__isnull=True),
                fields=("vm", "mac_address"),
                name="maasserver_virtualmachineinterface_no_iface_uniq",
            ),
        ),
        migrations.AddConstraint(
            model_name="virtualmachineinterface",
            constraint=models.UniqueConstraint(
                condition=models.Q(host_interface__isnull=False),
                fields=("vm", "mac_address", "host_interface"),
                name="maasserver_virtualmachineinterface_iface_uniq",
            ),
        ),
    ]
